#include <Adafruit_NeoPixel.h>
  
#define ledPIN 6   //RGB接D6
#define potPIN 0   //颜色电位器接A0
#define BrightPIN 1  //亮度电位器接A1
 
int val = 0;       // 读取存储传感器的值
int bright = 0;
uint8_t r, g, b; 
 
Adafruit_NeoPixel strip = Adafruit_NeoPixel(64, ledPIN, NEO_GRB + NEO_KHZ800);
 
void setup() {
  pinMode(ledPIN, OUTPUT);  // declare the ledPin as an OUTPUT 
  strip.begin();//adjust brightness here
  strip.show(); // Initialize all pixels to 'off'
}
  
void loop() {
  //rainbowRGB(10);
  val = analogRead(potPIN);    // read the value from the sensor
  bright = analogRead(BrightPIN);
  bright = map(bright,0,1023,0,255);
  strip.setBrightness(bright);
  
  if (val<10) {
  colorWipe(strip.Color(255, 255, 255), 20); // Red
  } else  {
     colorVal(val,2);
    }
}
 
void colorVal(int v, uint8_t wait) {
  uint8_t r=0, g=0, b=0;
  
  if ((v>=0) && (v<256))
    {r=255;g=v;b=0;}
  if ((v>256) && (v<512))
    {r=512-v;g=255;b=0;}
  if ((v>512) && (v<768))
    {r=0;g=255;b=v-512;}
  if ((v>768) && (v<=1024))
    {r=0;g=1024-v;b=255;}
    
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, r, g, b);
      strip.show();
      delay(wait);
  }
}
  
// Fill the dots one after the other with a color

void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, c);
      strip.show();
      delay(wait);
  }
}
 
void rainbowRGB(uint8_t wait) {
  uint16_t i;
    for(i=0; i<strip.numPixels(); i++) {
      nextRGB();
      strip.setPixelColor(i, r, g, b);
    }
    strip.show();
    delay(wait);
}
  
void nextRGB() {
    if ( r == 255 && g < 255 && b == 0 )  { g++; }
    if ( g == 255 && r > 0 && b == 0 )    { r--; }
    if ( g == 255 && b < 255 && r == 0 )  { b++; }
    if ( b == 255 && g > 0 && r == 0 )    { g--; }
    if ( b == 255 && r < 255 && g == 0 )  { r++; }
    if ( r == 255 && b > 0 && g == 0 )    { b--; }
}
